/* Sudoku Solving Program using Plain C */
/*
A BRIEF NOTE :
This version of the Program displays the board pattern, does the work of I/P-O/P
operations & serves as a BASE on which you can choose to code your own Recursive
routines.

I wish u all the very best in your endeavour.
My only request is to acknowledge me in the Credits.

-Rajiv A Iyer  AKA  Gandalf_The_White
*/


/*
  I/P -O/P & Displaying operations programmed & conceived by :
  Rajiv A Iyer
  SE Comps, SIES GST, Nerul

  E-Mail :  rai_gandalf@yahoo.co.in
*/


/* Source Code : */
#include<stdio.h>
#include<conio.h>
#include<process.h>
#define TRUE 1
#define FALSE 0
#define NULL 0
#define err_rec_lmt 1000
#define err_ip    "\n\nINVALID INPUT!! Please Try Again !!"
#define err_file  "\n\nERROR!! FILE CANNOT BE OPENED!!"

/* Global Variable declarations */
int sol[10][10];
int ip_mode,op_mode;
FILE *fp;


/* Function Declarations */

/* I/P - O/P Functions & I/P Verification */
void ip_solvesudoku();
void ip_storesudoku();
void change_settings();
void ascertain_mode();
int verify_ipval(int ip[10][10]);

/* Board Displaying Funcs */
void align_N_create(int ip[10][10]);
void create_boardpattern(int i,int c[]);


/* MAIN PROGRAM */
void main()
{
  char choice;

  clrscr();
  printf("*******  TEST   VERSION  *******");
  getch();

  do{
    clrscr();
    printf("MAIN MENU");
    printf("\n\n\n1. SOLVE a Sudoku Puzzle");
    printf("\n\n2. STORE a Sudoku Puzzle & its Solution");
    printf("\n\n3. CHANGE Settings/Preferences");
    printf("\n\n4. Credits");
    printf("\n\n5. Exit");

    printf("\n\nEnter your choice :  ");
    scanf("%d",&choice);

    clrscr();

    switch(choice)
    {
      case 1:
        ascertain_mode();
        ip_solvesudoku();
        break;

      case 2:
        ip_storesudoku();
        break;

      case 3:
        change_settings();
        break;

      case 4:
        printf("Created & Conceived By : ENTER YOUR NAME");
        printf("\nCopyright 2005 - ENTER YOUR NAME");

        /* Acknowledgement for me */
        printf("\n\nI/P - O/P & Displaying Operations Conceived & Coded By :  Rajiv A Iyer");
        printf("\nE-Mail :  rai_gandalf@yahoo.co.in");

        // Any other Acknowledgements if any
        getch();
        break;

      case 5:
        break;

      default:
        printf("\a%s\a",err_ip);
        getch();
    }
    //getch();
  }while(choice!=5);
}


/* I/P-O/P Functions & I/P Verification Functions Begin */


/* This Routine asks for I/P from user to solve a Sudoku Puzzle & ATTEMPTS
   to solve it, by calling the Recursive routine : "solve_get_basic_vals()" */
void ip_solvesudoku()
{
  int i,j,k,n,ip[10][10],ipno_tmp;
  int flag;
  
  do{
    /* Initializing all the entries of array 'ip' & 'sol' to default value of '0' */
    for(i=0;i<=9;i++)
      for(j=0;j<=9;j++)
      {
        sol[i][j]=ip[i][j]=FALSE;
      }

    fp=fopen("op_solve_sudoku.txt","w");

    if(fp==NULL)
    {
      printf("%s",err_file);
      getch();
      return;
    }

    /* Calling function to create the board pattern intitially empty */
    align_N_create(sol);


    printf("\n\n\nEnter the number of nos. to be entered :  ");
    scanf("%d",&n);

    if(n==0 || n>=81)
    {
      printf("\aERROR!! \a%d Entries Cannot be Entered For Solving!!",n);
      getch();
      return;
    }


    /* The following commented code is used to check the displaying of the program
       for all 81 entries */
    /*
    else if(n==81)
    {
      for(i=1;i<=9;i++)
        for(j=1;j<=9;j++)
        {
          ip[i][j]=j;
          sol[i][j]=j;
        }
      break;
    }
    */

    if(ip_mode==1)
    {
      printf("Enter the Row no.,Column no. & the number to be entered :\n");
      for(i=0;i<n;i++)
      {
        scanf("%d%d",&j,&k);
        scanf("%d",&ipno_tmp);
        sol[j][k]=ip[j][k]=ipno_tmp;
      }
    }
    else
    {
      printf("\n\nEnter the entries Row wise (in the format : Col_no <space> entry) :");
      printf("\nJust Type '0' at the end of each Row-I/P :\n");
      for(i=1;i<=9;i++)
      { 
        printf("\n\nRow %d :\n",i);
        do{
          scanf("%d",&j);
          scanf("%d",&ipno_tmp);
          if(ipno_tmp!=0)
            sol[i][j]=ip[i][j]=ipno_tmp;
        }while(ipno_tmp!=0);
      }
    }

    /* Setting 'flag' as a flagging variable to O/P of routine 'verify_ipval()' */
    flag=verify_ipval(ip);

    if(!flag)
    {
      clrscr();
      flushall();
    }
  }while(!flag);

  clrscr();
  printf("\n\nREFRESHING THE BOARD");
  getch();
  clrscr();
  align_N_create(sol);
  getch();

  /* Initializing the sub-grids */
  //initialize_subgrids(sgrid);

  clrscr();
  printf("The Solution of this Sudoku Problem is :  ");
  getch();
  printf("PROCESSING.......This may take some time.....");
  getch();
  clrscr();

  /*
     NOTE TO Programmers :
     Give the external call to your developed Recursive Function here.
  */

  getch();
  fclose(fp);
}


/* This Function Asks user for I/P of the Newspaper, date of publishing of the
   Puzzle & then asks the user to fill the numbers already give.
   It then asks the user to enter the entire solution of the puzzle, which it
   stores in a file : "store_sud_sols.rtf"
*/
void ip_storesudoku()
{
  int i,j,k,n,ip[10][10],ipno_tmp;
  char pub_date[15],news_paper[30];

  /* Intializing all entries of 'sol' & 'ip' to default value of '0' */
  for(i=0;i<=9;i++)
    for(j=0;j<=9;j++)
    {
      sol[i][j]=ip[i][j]=FALSE;
    }

  /* Opening File */
  fp=fopen("save_sud_sols.txt","a");

  if(fp==NULL)
  {
    printf("%s",err_file);
    getch();
    return;
  }

  printf("\n\nEnter the Newspaper from which Puzzle was taken :  ");
  flushall();gets(news_paper);
  fprintf(fp,"\n\n\n\nFrom Newspaper :  %s",news_paper);

  printf("\n\Enter the Date of publishing of puzzle :  ");
  flushall();gets(pub_date);
  fprintf(fp,"\nDate of Publishsing :  %s",pub_date);

  printf("\n\n\nEnter the number of nos. to be entered :  ");
  fprintf(fp,"\n\n\nEnter the number of nos. to be entered :  ");
  scanf("%d",&n);
  fprintf(fp,"%d",n);

  printf("Enter the Row no.,Column no. & the number to be entered :\n");
  for(i=0;i<n;i++)
  {
    scanf("%d%d",&j,&k);
    scanf("%d",&ipno_tmp);
    ip[j][k]=ipno_tmp;
  }

  clrscr();
  printf("\n\nREFRESHING THE BOARD!! Writing into FILE!!");
  getch();
  fprintf(fp,"\n\nQUESTION/PUZZLE :  ");
  align_N_create(ip);
  getch();


  clrscr();
  printf("Enter the Solution of the Sudoku! Press Enter!");
  printf("\n\nEnter the entries Row wise :\n");
  for(i=1;i<=9;i++)
    for(j=1;j<=9;j++)
      scanf("%d",&ip[i][j]);

  clrscr();
  printf("\n\nREFRESHING THE BOARD!! Writing into FILE!!");
  getch();
  fprintf(fp,"\n\nSOLUTION :  ");
  align_N_create(ip);
  getch();

  /* Closing File */
  fclose(fp);
}


/* The below routine is for changing the default settings used for I/P - O/P
   operations. The changes r made to a file : "settings_sud.txt", that
   must be in the same folder as the program */
void change_settings()
{
  int ch,sr_no,setted_val;
  int present_ip_mode,new_ip_mode;
  int present_op_mode,new_op_mode;
  char parameter[50];

  do{
    clrscr();
    /* Opening file */
    fp=fopen("settings_sud.txt","r");

    if(fp==NULL)
    {
      printf("\a%s\a",err_file);
      getch();
      return;
    }

    while(!feof(fp))
    {
      fscanf(fp,"%d %s %d",&sr_no,parameter,&setted_val);

      switch(sr_no)
      {
        case 1:
          printf("The default mode of Inputting is of the format :");
          if(setted_val==1)
            printf("\nRow_No <space> Col_No <space> Entry");
          else
          {
            printf("Row-wise Entries, i.e.");
            printf("\nRow 1 :  Col_No <space> Entry......");
            printf("\nRow 2 :  Col_No <space> Entry......");
            printf("\n\n& so on");
          }
          present_ip_mode=setted_val;
          break;

        case 2:
          if(setted_val==1)
          {
            printf("\n\n\nAt Present, Recursive Calls/Moves are displayed");
            printf("\ni.e., Individual Steps are displayed");
          }
          else
          {
            printf("\n\n\nAt Present, Recursive Calls/Moves are NOT displayed");
            printf("\ni.e., Individual Steps are NOT displayed\n");
          }
          present_op_mode=setted_val;
          break;

        default:
          printf("\n\nThis File has been Modified or Changed!!");
          printf("\nPlease restore it to its original format");
      }
      getch();
    }
    fclose(fp);


    printf("\n\n\nSETTINGS CHANGE MENU :\n");
    printf("\n1. Change I/P Mode\n2. Change O/P Mode\n3. Restore All Defaults");
    printf("\n4. Go Back to Main Menu\n5. Exit");
    printf("\nEnter your choice :  ");
    flushall();scanf("%d",&ch);


    switch(ch)
    {
      case 1:
        /* Opening the File in Write Mode */
        fp=fopen("settings_sud.txt","w");

        new_ip_mode=(present_ip_mode+1)%2;

        fprintf(fp,"1  Default_I/P_Mode=  %d",new_ip_mode);
        fprintf(fp,"\n2  Default_Rec_O/P_Mode=  %d",present_op_mode);

        printf("\n\n\nI/P Mode has been Changed!");
        fclose(fp);
        break;

      case 2:
        /* Opening the File in Write Mode */
        fp=fopen("settings_sud.txt","w");

        new_op_mode=(present_op_mode+1)%2;

        fprintf(fp,"1  Default_I/P_Mode=  %d",present_ip_mode);
        fprintf(fp,"\n2  Default_Rec_O/P_Mode=  %d",new_op_mode);

        printf("\n\n\nO/P Mode has been Changed!");
        fclose(fp);
        break;

      case 3:
        if(present_ip_mode==1 && present_op_mode==1)
          printf("\n\nDefault Settings Already exists!!");
        else
        {
          /* Opening File in Write Mode */
          fp=fopen("settings_sud.txt","w");

          fprintf(fp,"1  Default_I/P_Mode=  1");
          fprintf(fp,"\n2  Default_Rec_O/P_Mode=  1");

          printf("\n\n\nDefault Settings Restored!!");
          fclose(fp);
        }
        break;

      case 4:
        break;

      case 5:
        exit(1);

      default:
        printf("%s",err_ip);
    }
    getch();
  }while(ch!=4);
}



/* The following routine ascertains the I/P Mode & O/P Mode & stores the
   mode values in Global Variables 'ip_mode' & 'op_mode' */
void ascertain_mode()
{
  int sr_no,setted_val;
  char parameter[50];

  /* Opening file */
  fp=fopen("settings_sud.txt","r");

  if(fp==NULL)
  {
    printf("\a%s\a",err_file);
    getch();
    return;
  }

  while(!feof(fp))
  {
    fscanf(fp,"%d %s %d",&sr_no,parameter,&setted_val);
    switch(sr_no)
    {
      case 1:
        ip_mode=setted_val;
        break;

      case 2:
        op_mode=setted_val;
        break;
    }
  }

  /* Closing File */
  fclose(fp);
}



/* This function verifies the validity of the I/P entered by user
   & returns a value of '1' if I/P is valid & '0' otherwise
   The rules for deciding validity is the same as the Sudoku rules */
int verify_ipval(int ip[10][10])
{
  int i,j,p,q;
  int temp[10];

  /* Testing for I/P invalidity if I/P exceeds '9' */
  for(i=1;i<=9;i++)
    for(j=1;j<=9;j++)
      if(ip[i][j]>9)
      {
        printf("%s",err_ip);
        printf("\n\nEntry  %d   to be placed in Row  %d  &  Column  %d  is invalid!!",ip[i][j],i,j);
        getch();
        return FALSE;
      }

  for(i=1;i<=9;i++)
  {
    /* Copying entries of present row 'i' into array 'temp' */
    for(j=1;j<=9;j++)
      temp[j]=ip[i][j];

    /* Checking for repeated entries in 'temp', i.e. Checking for repeated
       entries in a Row */
    for(p=1;p<=9;p++)
      for(q=p+1;q<=9;q++)
        if((temp[p]==temp[q]) && (temp[p]!=FALSE))
        {
          printf("%s",err_ip);
          printf("\n\nEntry %d appears in the Row %d, both at  Column  %d  &  Column  %d",temp[p],i,p,q);
          getch();
          return FALSE;
        }

    /* Resetting all the values of 'temp' to '0' */
    /* If Re-setting is NOT done, then false comparisions may be made
       in the subsequent analysis & hence incorrect results may be obtained */
    for(j=1;j<=9;j++)
      temp[j]=FALSE;


    /* Copying entries of column 'i' into array temp */
    for(j=1;j<=9;j++)
      if(ip[j][i]!=FALSE)
        temp[j]=ip[j][i];

    /* Checking for repeated entries in 'temp', i.e. Checking for repeated
       entries in a column */
    for(p=1;p<=9;p++)
      for(q=p+1;q<=9;q++)
        if((temp[p]==temp[q]) && (temp[p]!=FALSE))
        {
          printf("%s",err_ip);
          printf("\n\nEntry %d appears in the Column %d, both at  Row  %d  &  Row  %d",temp[p],i,p,q);
          getch();
          return FALSE;
        }
  }
  /* If control reaches here, then obviously, in the above for loop, the
     "return 0" statement xecuted 0 times, i.e., I/P is valid. Hence returning 1 */
  return TRUE;
}




/* Display Routines Begin */
/* This function aligns the text for the Sudoku Board creation &
   numbers the rows & columns */
void align_N_create(int sol[10][10])
{
  int i,j,cr_no=0,align;
  int c[10];

  clrscr();
  flushall();
  printf("\n\n\n");
  fprintf(fp,"\n\n\n");
  for(i=0;i<34;i++)
  {
    printf(" ");
    fprintf(fp," ");
  }
  printf("SUDOKU BOARD :");
  printf("\n\n");
  fprintf(fp,"SUDOKU BOARD :");
  fprintf(fp,"\n\n");

  /* Helps in Centre-aligning the Sudoku Board */
  align=(80-64)/2;

  /* Creating a Horizontal printing pattern "C O L U M N S", aligned
     as per the Sudoku Board.
     Also, Numbering the columns of the Sudoku board that is about to
     be created & aligning it as per the Sudoku Board's alignment
  */

  /* In the 'i=0' iteration of the loop, we perform the work of printing
     "C O L U M N S", while in the 'i=1' iteration of the loop, we do the work
     of numbering the Columns */

  for(i=0;i<2;i++)
  {
    /* Beginning on a new line */
    printf("\n\n");
    fprintf(fp,"\n\n");


    /* Leaving 'align' no. of spaces for Centre-alignment / Centre-justfication */
    for(j=0;j<align;j++)
    {
      printf(" " );
      fprintf(fp," " );
    }
    /* Leaving 10 spaces for Remaining alignment */
    for(j=0;j<10;j++)
    {
      printf(" ");
      fprintf(fp," ");
    }

    if(i==0)
      /* Creating Horizontal "C O L U M N S" pattern */
      for(j=1;j<54;j++)
        switch(j)
        {
          case 9:
            printf("C");
            fprintf(fp,"C");
            break;
          case 15:
            printf("O");
            fprintf(fp,"O");
            break;
          case 21:
            printf("L");
            fprintf(fp,"L");
            break;
          case 27:
            printf("U");
            fprintf(fp,"U");
            break;
          case 33:
            printf("M");
            fprintf(fp,"M");
            break;
          case 39:
            printf("N");
            fprintf(fp,"N");
            break;
          case 45:
            printf("S");
            fprintf(fp,"S");
            break;
          default:
            printf(" ");
            fprintf(fp," ");
        }

    else
      /* Numbering the Columns */
      for(j=1;j<54;j++)
        switch(j)
        {
          case 3:
            printf("1");
            fprintf(fp,"1");
            break;
          case 9:
            printf("2");
            fprintf(fp,"2");
            break;
          case 15:
            printf("3");
            fprintf(fp,"3");
            break;
          case 21:
            printf("4");
            fprintf(fp,"4");
            break;
          case 27:
            printf("5");
            fprintf(fp,"5");
            break;
          case 33:
            printf("6");
            fprintf(fp,"6");
            break;
          case 39:
            printf("7");
            fprintf(fp,"7");
            break;
          case 45:
            printf("8");
            fprintf(fp,"8");
            break;
          case 51:
            printf("9");
            fprintf(fp,"9");
            break;
          default:
            printf(" ");
            fprintf(fp," ");
        }
  }//End of initial Pattern creation process


  /* Main Board Pattern creation begins */
  for(i=0;i<=27;i++)
  {
    /* Tracks the current row no. for which the current iteration is done
       or pattern produced */
    if(i%3==0)
      cr_no++;

    /* Beginning on a new line */
    printf("\n");
    fprintf(fp,"\n");

    /* Leaving 'align' no. of spaces for Centre-alignment / Centre-justfication */
    for(j=0;j<align;j++)
    {
      printf(" " );
      fprintf(fp," " );
    }

    /* Initializing all the entries of array c[10] to default value of '0' */
    for(j=0;j<=9;j++)
      c[j]=FALSE;


    if(i==0)
    {
      /* Takes care of printing the 0th line - consisting of only "_"
        (underscores) & align text accordingly */

      /* Leaving 10 spaces for alignment */
      for(j=0;j<10;j++)
      {
        printf(" ");
        fprintf(fp," " );
      }

      /* Creating the horizontal "_" pattern */
      for(j=1;j<54;j++)
      {
        if(j%6==0)
        {printf(" ");fprintf(fp," ");}
        else
        {printf("_");fprintf(fp,"_");}
      }
    }

    else if(i%3==0)
    {
      /* Takes care of 3rd,6th,... lines, that displays "|____" simultaneously
         & align text accordingly */

      /* Leaving 9 spaces for alignment */
      for(j=0;j<9;j++)
      {
        printf(" ");
        fprintf(fp," ");
      }

      /* Calling fuction to create the present row pattern */
      create_boardpattern(i,c);
    }

    else if(i==8||i==11||i==14||i==17)
    {
      /* Will print "R", "O", "W" & "S" in the 8th, 11th, 14th & 17th
         rows respectively, display row nos. & align text accordingly */
      switch(i)
      {
        case 8:
          printf("R");
          fprintf(fp,"R");
          break;
        case 11:
          printf("O");
          fprintf(fp,"O");
          break;
        case 14:
          printf("W");
          fprintf(fp,"W");
          break;
        case 17:
          printf("S");
          fprintf(fp,"S");
          break;
      }

      /* Leaving 4 Spaces */
      for(j=0;j<4;j++)
      {
        printf(" ");
        fprintf(fp," ");
      }

      /* Printing the current row no. */
      printf("%d",cr_no);
      fprintf(fp,"%d",cr_no);

      /* Leaving 3 spaces for alignment */
      for(j=0;j<3;j++)
      {
        printf(" ");
        fprintf(fp," ");
      }

      /* Copying all the values of the array sol[10][10],
         belonging to the present row 'cr_no' into array c[10] */
      /* Those entries of c[10] with value 'FALSE' signifies that printing must
         be normal in that column block, while those with (+)ve values
         suggests that an entry must be placed in tht column block & hence
         printing must be modified */
      for(j=1;j<=9;j++)
        if(sol[cr_no][j]!=FALSE)
          c[j]=sol[cr_no][j];

      /* Calling function to print the present row pattern */
      create_boardpattern(i,c);
    }

    else if(i==2||i==5||i==20||i==23||i==26)
    {
      /* Takes care of 2nd,5th lines - these r centre lines of
         respective rows no. 1,2,7,8,9 */

      /* Leaving 5 Spaces */
      for(j=0;j<5;j++)
      {
        printf(" ");
        fprintf(fp," ");
      }

      /* Printing the current row no. */
      printf("%d",cr_no);
      fprintf(fp,"%d",cr_no);

      /* Leaving 3 spaces for alignment */
      for(j=0;j<3;j++)
      {
        printf(" ");
        fprintf(fp," ");
      }

      /* Copying all the values of the array sol[10][10],
         belonging to the present row 'cr_no' into array c[10] */
      /* Those entries of c[10] with value 'FALSE' signifies that printing must
         be normal in that column block, while those with (+)ve values
         suggests that an entry must be placed in tht column block & hence
         printing must be modified */
      for(j=1;j<=9;j++)
        if(sol[cr_no][j]!=FALSE)
          c[j]=sol[cr_no][j];

      /* Calling function to print the present row pattern */
      create_boardpattern(i,c);
    }

    else
    {
      /* Takes care of all other rows */
      /* Leaving 9 Spaces for alignment */
      for(j=0;j<9;j++)
      {
        printf(" ");
        fprintf(fp," ");
      }
      create_boardpattern(i,c);
    }
  }//End of Master for loop (i loop)
  printf("\n\n");
  fprintf(fp,"\n\n");
}//Function Ends


/* This function creates the actual Sudoku Board pattern */
void create_boardpattern(int i,int c[])
{
  int j,ccol_no=1;
  /* Printing the Left Wall character "|" */
  printf("|");
  fprintf(fp,"|");

  /* Printing the rest of the horizontal line */
  for(j=1;j<54;j++)
  {
    if(j%6==0)
    {ccol_no++;printf("|");fprintf(fp,"|");}
    else
    {
      if(i%3==0)
        /* Refer the corresponding "i%3" condition in
           function "align_N_create()" to understand */
      {printf("_");fprintf(fp,"_");}

      else
      {
        if(c[ccol_no]==FALSE)
        {printf(" ");fprintf(fp," ");}
        else
        {
          if(c[ccol_no]==FALSE)
          {
            printf(" ");
            fprintf(fp," ");
          }
          else
          {
            printf("  ");//2 spaces
            fprintf(fp,"  ");
            printf("%d",c[ccol_no]);
            fprintf(fp,"%d",c[ccol_no]);
            printf("  ");//2 spaces
            fprintf(fp,"  ");
            j+=4;
          }
        }
      }
    }
  }

  /* Printing the Right Wall character "|" */
  printf("|");
  fprintf(fp,"|");
}


